package fr.emse.gitlab.saref.managers;

import com.opencsv.CSVParser;
import com.opencsv.CSVParserBuilder;
import com.opencsv.CSVReader;
import com.opencsv.CSVReaderBuilder;
import fr.emse.gitlab.saref.Main;
import org.apache.commons.io.IOUtils;
import org.eclipse.jgit.util.StringUtils;

import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.List;

public class GenerateRDFaManager {

    public static void GenerateRDFaManager(String categoryChanger, String repoName, String href, File CSV, File HTML, String identifier) {
        String row = "";

        FileWriter htmlWriter = null;

        try{

            htmlWriter = new FileWriter(HTML);

            String header = IOUtils.toString(Main.class.getClassLoader().getResourceAsStream("themis/header.html"), StandardCharsets.UTF_8);
            String body = IOUtils.toString(Main.class.getClassLoader().getResourceAsStream("themis/body.html"), StandardCharsets.UTF_8);
            String footer = IOUtils.toString(Main.class.getClassLoader().getResourceAsStream("themis/footer.html"), StandardCharsets.UTF_8);

            header = header.replace("@ontologyName", repoName).replace("@href", href + "/" + identifier + "/");

            body = body.replace("@docType", StringUtils.capitalize(identifier)).replace("@ontologyName", repoName);

            htmlWriter.write(header);
            htmlWriter.write(body);


            BufferedReader csvReader = new BufferedReader(new FileReader(CSV));

            List<String[]> allData = readDataFromCustomSeperator(CSV);


            if (identifier.equals("requirements")) {

                for (String[] data : allData) {
                    if (data[1].equals("Category")) {
                        continue;
                    } else {
                        if (categoryChanger.equals("") || categoryChanger.equals(data[1]) || !data[1].equals("Category")) {

                            if (!categoryChanger.equals(data[1]) && !categoryChanger.equals("Category")) {
                                if (categoryChanger.equals("")) {
                                    categoryChanger = data[1];
                                } else {
                                    categoryChanger = data[1];
                                    String endTableData = "</table> \n" +
                                            "\n" +
                                            "<p>\n" +
                                            "</p>\n" +
                                            "\n";
                                    htmlWriter.write(endTableData);
                                }


                                categoryChanger = data[1];
                                String entrytoTable2 = "<table align=\"center\" border=\"1\"  prefix=\"vtc: https://w3id.org/def/vtc#\">\n";
                                htmlWriter.write(entrytoTable2);
                                String category = "<caption>Requirements for the \"" + categoryChanger + "\" category</caption>\n";
                                htmlWriter.write(category);

                                String entry = "<tr>\n" +
                                        "    <th>Id</th>\n" +
                                        "    <th>Requirement</th>\n" +
                                        "  </tr>\n" +
                                        "\n" +
                                        "<tr id=\"" + data[0] + "\" resource=\"requirement/" + data[0] + "\" typeof=\"vtc:Requirement\" property=\"vtc:category\" content=\"" + data[1] + "\">\n" +
                                        "    <td property=\"vtc:requirementId\">" + data[0] + "</td>\n" +
                                        "    <td property=\"dc:description\">" + data[2] + "</td>\n" +
                                        "  </tr>\n" +
                                        "\n";
                                htmlWriter.write(entry);
                            } else {
                                categoryChanger = data[1];

                                String entry = "<tr id=\"" + data[0] + "\" resource=\"requirement/" + data[0] + "\" typeof=\"vtc:Requirement\" property=\"vtc:category\" content=\"" + data[1] + "\">\n" +
                                        "    <td property=\"vtc:requirementId\">" + data[0] + "</td>\n" +
                                        "    <td property=\"dc:description\">" + data[2] + "</td>\n" +
                                        "  </tr>\n" +
                                        "\n";
                                htmlWriter.write(entry);
                            }
                        }

                    }
                }

            } else {
                for (String[] data : allData) {
                    if (data[2].equals("Category")) {
                        continue;
                    } else {
                        if (categoryChanger.equals("") || categoryChanger.equals(data[2]) || !data[2].equals("Category")) {

                            if (!categoryChanger.equals(data[2]) && !categoryChanger.equals("Category")) {
                                if (categoryChanger.equals("")) {
                                    categoryChanger = data[2];
                                } else {
                                    categoryChanger = data[2];
                                    String endTableData2 = "</table> \n" +
                                            "\n" +
                                            "<p>\n" +
                                            "</p>\n" +
                                            "\n";
                                    htmlWriter.write(endTableData2);
                                }


                                categoryChanger = data[2];
                                String entrytoTable2 = "<table align=\"center\" border=\"1\"  prefix=\"vtc: https://w3id.org/def/vtc#\">\n";
                                htmlWriter.write(entrytoTable2);
                                String category = "<caption>Tests for the \"" + categoryChanger + "\" category</caption>\n";
                                htmlWriter.write(category);
                                if (!data[1].isEmpty()) {
                                    String entry = "<tr>\n" +
                                            "    <th>Id</th>\n" +
                                            "    <th>Requirement</th>\n" +
                                            "    <th>Test</th>\n" +
                                            "  </tr>\n" +
                                            "\n" +
                                            "<tr id=\"" + data[1] + "\" resource=\"testCaseDesign/" + data[0] + "\" typeof=\"vtc:TestCaseDesign\">\n" +
                                            "    <td property=\"vtc:testId\">" + data[0] + "</td>\n" +
                                            "    <td><span property=\"vtc:comesFromRequirement\" href=\"requirement/" + data[1] + "\"><a href=\"../site/requirements.html#" + data[1] + "\">" + data[1] + "</a></span></td>\n" +
                                            "    <td property=\"vtc:desiredBehaviour\">" + data[3] + "</td>\n" +
                                            "  </tr>\n" +
                                            "\n";
                                    htmlWriter.write(entry);
                                } else {
                                    String entry = "<tr>\n" +
                                            "    <th>Id</th>\n" +
                                            "    <th>Test</th>\n" +
                                            "  </tr>\n" +
                                            "\n" +
                                            "<tr resource=\"testCaseDesign/" + data[0] + "\" typeof=\"vtc:TestCaseDesign\">\n" +
                                            "    <td property=\"vtc:testId\">" + data[0] + "</td>\n" +
                                            "    <td property=\"vtc:desiredBehaviour\">" + data[3] + "</td>\n" +
                                            "  </tr>\n" +
                                            "\n";
                                    htmlWriter.write(entry);
                                }
                            } else {
                                categoryChanger = data[2];

                                String entry = "<tr resource=\"testCaseDesign/" + data[0] + "\" typeof=\"vtc:TestCaseDesign\">\n" +
                                        "    <td property=\"vtc:testId\">" + data[0] + "</td>\n" +
                                        "    <td><span property=\"vtc:comesFromRequirement\" href=\"requirement/" + data[1] + "\"><a href=\"../site/requirements.html#" + data[1] + "\">" + data[1] + "</a></span></td>\n" +
                                        "    <td property=\"vtc:desiredBehaviour\">" + data[3] + "</td>\n" +
                                        "  </tr>\n" +
                                        "\n";
                                htmlWriter.write(entry);
                            }
                        }

                    }
                }
            }

            String endTableData = "</table> \n" +
                    "\n" +
                    "<p>\n" +
                    "</p>\n" +
                    "\n";
            htmlWriter.write(endTableData);

            htmlWriter.write(footer);


        } catch (IOException e) {
            e.printStackTrace();
        } finally{
            try {
                if (htmlWriter != null) {
                    htmlWriter.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }



    public static List<String[]> readDataFromCustomSeperator(File file) {
        try {
            // Create an object of file reader class with CSV file as a parameter.
            FileReader filereader = new FileReader(file);

            // create csvParser object with
            // custom seperator semi-colon
            CSVParser parser = new CSVParserBuilder().withSeparator(';').build();

            // create csvReader object with parameter
            // filereader and parser
            CSVReader csvReader = new CSVReaderBuilder(filereader)
                    .withCSVParser(parser)
                    .build();

            // Read all data at once
            List<String[]> allData = csvReader.readAll();
            return allData;

        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


}
